// a small program that demonstrates the commandoptions library
#include <iostream>

#include "commandoptions"


int main(int argc, const char *argv[])
{
  commandoptions c;

  bool beep = false;

  int no_of_hits = 3;
  std::string boink_sound = "*boink*";
  std::string ouch_sound = "*ouch*";
  std::string victim;
    
  c.register_flag(beep, "beep", 'b', "Turn on beeping");
  c.register_option(no_of_hits, "hits", 'h', "How many times to hit victim", "NUMBER");
  c.register_option(boink_sound, "", 's', "How hitting victim sounds", "SOUND");
  c.register_option(ouch_sound, "help-cry", '\0', "Victim response", "SOUND");
  c.register_argument(victim, "victim", "");
  
  try {
    c.process_command_line(argc, argv);
  }
  catch (commandoptions_error &ex) {
    std::cerr << "Error: " << ex.what() << endl;
    return 1;
  }

  if (no_of_hits > 0) {
    std::cout << "Now hitting " << victim << ' '
	      << no_of_hits << " times:" << std::endl;
      
    for (int i = 0; i < no_of_hits; ++i)
      std::cout << boink_sound << ' ' << ouch_sound << std::endl;
  }
  
  if (beep)
    std::cout << "*beep*" << std::endl;
}
